<?php
require_once dirname(dirname(dirname(__DIR__))).'/app/autoload.php';

use Koob\DatabaseBundle\Controller\DatabaseController;
use Koob\LocalBundle\Controller\LocalController;
use Koob\LocalBundle\Controller\LocalDatabaseController;

$con = new DatabaseController;
$local = new LocalController;
$localCon = new LocalDatabaseController;

$con->setHost($local->getParameter('host'))
	->setPass($local->getParameter('pass'))
	->setUser($local->getParameter('user'))
	->setDatabase($local->getParameter('database'));

$game = lcfirst($localCon->getParameter("game"));

$whereText = $con->select(['max(id) as id'])
  ->from('report'.ucfirst($game))
  ->build()
  ->getSql();
$lastests = $con->startQuery()
  ->select(['bigLap', 'income', 'outcome'])
  ->from('report'.ucfirst($game))
  ->where("id = ($whereText)")
  ->build()
  ->query()
  ->fetchAssoc()[0];
$con->close();
$lastests['income'] = (int) $lastests['income'];
$lastests['outcome'] = (int) $lastests['outcome'];

$results = $con->startQuery()
  ->select(['sum(income) as income', 'sum(outcome) as outcome'])
  ->from('report'.ucfirst($game))
  ->where(['biglap' => $lastests['bigLap']])
  ->build()
  ->query()
  ->fetchAssoc()[0];
$con->close();
$results['income'] = (int) $results['income'];
$results['outcome'] = (int) $results['outcome'];

$replys['lastests'] = $lastests;
$replys['results'] = $results;
$replys['game'] = $game;

echo json_encode($replys);