<?php
require_once dirname(dirname(dirname(__DIR__))).'/app/autoload.php';

use Koob\DatabaseBundle\Controller\DatabaseController;
use Koob\LocalBundle\Controller\LocalController;
use Koob\LocalBundle\Controller\LocalDatabaseController;

$con = new DatabaseController;
$local = new LocalController;
$localCon = new LocalDatabaseController;

$con->setHost($local->getParameter('host'))
	->setPass($local->getParameter('pass'))
	->setUser($local->getParameter('user'))
	->setDatabase($local->getParameter('database'));

$game = lcfirst($localCon->getParameter("game"));

$content = $con->startQuery()
  ->select(['content'])
  ->from($game)
  ->where(['id' => 1])
  ->build()
  ->query()
  ->fetchAssoc()[0]['content'];
$con->close();
$contents = json_decode($content, 1);
$gameTag = $game.$contents['game'];

$results = $con->startQuery()
  ->select(['id', 'amount', 'bonus', 'time', 'date', 'month', 'year'])
  ->from('reportMoney', 'money')
  ->where(['game' => $gameTag])
  ->build()
  ->query()
  ->fetchAssoc();
$con->close();

$whereText = $con->select(['userId'])
  ->from($game)
  ->where('id > 1')
  ->build()
  ->getSql();
$allCredits = $con->startQuery()
  ->select(['sum(net) as net', 'sum(bonus) as bonus'])
  ->from('money', 'money')
  ->where("userId in ($whereText)")
  ->build()
  ->query()
  ->fetchAssoc()[0];
$con->close();

$replys['results'] = $results;
$replys['allCredits'] = $allCredits;

echo json_encode($replys);