<?php
require_once dirname(dirname(dirname(__DIR__))).'/app/autoload.php';
date_default_timezone_set('Asia/Bangkok');

use Koob\LineApiBundle\Controller\LineApiController;
use Koob\DatabaseBundle\Controller\DatabaseController;
use Koob\LocalBundle\Controller\LocalController;
use Koob\LocalBundle\Controller\LocalDatabaseController;

$api = new LineApiController;
$con = new DatabaseController;
$local = new LocalController;
$localCon = new LocalDatabaseController;

$api->setAccessToken($local->getParameter('accessToken'))
	->setMethod('push');

$con->setHost($local->getParameter('host'))
	->setPass($local->getParameter('pass'))
	->setUser($local->getParameter('user'))
	->setDatabase($local->getParameter('database'));

$operator = $_POST['operator'];
$id = $_POST['id'];
$amount = $_POST['amount'];
$bonus = $_POST['bonus'];
$user = $_POST['user'];
  
$playRoom = $local->getParameter('playRoom');
$tags = $local->getParameter('tags');
$game = lcfirst($localCon->getParameter("game"));

$data = $con->startQuery()
  ->select(['content'])
  ->from($game)
  ->where(['id' => 1])
  ->build()
  ->query()
  ->fetchAssoc()[0]['content'];
$con->close();
$data = str_replace("\n", "enter", $data);
$datas = json_decode($data, 1);
if ($datas['status'] == 'down') {
  echo "ยังไม่เปิดเกม";
  return;
}

$databases = $con->startQuery()
  ->select(['net', 'name', 'bonus'])
  ->from('money', 'money')
  ->where(['id' => $id])
  ->build()
  ->query()
  ->fetchAssoc()[0];
$con->close();
if (empty($databases)) {
  echo "Something went wrong. Contact Admin";
  return;
}
$name = json_decode($databases['name'], 1);
$databases['net'] += $amount;
if ($amount > 0) {
  $prefix = "เพิ่มเครดิต";
  $showMoney = "+$amount";
  $databases['bonus'] += (int) $amount*$bonus/100;
  $bonusText = $bonus == 0 ? '' : "+{$bonus}%";
  $bonusRemainingText = $databases['bonus'] == 0 ? '' : '💸'.$databases['bonus'];
} else {
  $prefix = "ลดเครดิต";
  $showMoney = $amount;
  $databases['bonus'] = 0;
  $bonusText = '';
  $bonusRemainingText = '';
}
$replyText = "$prefix $name {$showMoney}{$bonusText} = 💰".$databases['net'].$bonusRemainingText;
$updates = [
  'net'      => $databases['net'],
  'bonus'    => $databases['bonus'],
];
sort($tags);
foreach ((array) $tags as $tag)
{
  if ($amount >= $tag) {
    $updates = array_merge($updates, ['tag' => $tag]);
  }
  if ($datas['recc'] == 'yes') {
    $updates = array_merge($updates, ['count' => 0, 'wage' => 0]);
  }
}

$con->startQuery()
  ->update($updates)
  ->set('money', 'money')
  ->where(['id' => $id])
  ->build()
  ->query()
  ->close();
$con->startQuery()
  ->insert([
    'amount' => $amount,
    'bonus'  => (int) $bonus,
    'time'   => date('H:i'),
    'date'   => date('j'),
    'month'  => date('n'),
    'year'   => date('Y'),
    'user'   => $user,
    'game'   => $game.$datas['game'],
  ])
  ->into('reportMoney', 'money')
  ->build()
  ->query()
  ->close();

$api->startApi()
		->setDestination($playRoom)
		->setMessage($replyText)
		->send()
		->close();

echo $replyText;