$("#modalAmount").keydown(function (e) {
  if (e.which == 13) {
    checkBonus();
  }
});

function updateUser()
{
  let table = $("#userBody");
  let response = '';
  let xmlhttp = new XMLHttpRequest();
  table.empty();
  xmlhttp.onreadystatechange = function () {
    if (this.readyState == 4 && this.status == 200) {
      response = JSON.parse(this.responseText);
      $.each(response, function (key, value) {
        table.append("<tr><td class='font-weight-bold'>"+value.id+"</td>"+
        "<td class='text-left' id='name"+value.id+"'>"+value.name+"</td>"+
        "<td id='net"+value.id+"'>"+value.net+"</td>"+
        "<td id='bonus"+value.id+"'>"+value.bonus+"</td>"+
        "<td><button id='"+value.id+"' class='btn btn-success col-8' data-toggle='modal' data-target='#topupModal' onclick='updateModal(this)'>topup</button></td>");
      });
      $("#userTable").DataTable();
    }
  };
  xmlhttp.open("GET", "../dist/ajax/getAllUser.php", true);
  xmlhttp.send();
}

function updateModal(e)
{
  //show select first
  $("#bonusSelect").val(0);
  $("#bonusInput").val("");
  $("#bonusSelect").show();
  $("#bonusInput").hide();

  //set default
  $("#modalAmount").val("");
  $("#radioIncrease").prop('checked', true);
  $("#bonusInput").hide();
  $("#bonusSelect").show();
  $("#bonusSelect").attr('disabled', false);

  //set current id, name, net, bonus
  $("#modalRefresh").attr("name", e.id);
  $("#modalTitle").text($("#name"+e.id).text());
  $("#modalNet").text($("#net"+e.id).text());
  $("#modalBonus").text($("#bonus"+e.id).text());

  //update net
  updateModalNet();
}

function updateModalNet()
{
  let response = '';
  let xmlhttp = new XMLHttpRequest();
  $("#modalNet").text(0);
  $("#modalBonus").text(0);
  xmlhttp.onreadystatechange = function () {
    if (this.readyState == 4 && this.status == 200) {
      response = JSON.parse(this.responseText);
      $("#modalNet").text(response.net);
      $("#modalBonus").text(response.bonus);
    }
  };
  xmlhttp.open("POST", "../dist/ajax/getEachNet.php", true);
  xmlhttp.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
  xmlhttp.send("id=" + $("#modalRefresh").attr("name"));
}

function updateModalSelect(e)
{
  if (e.value == '-1') {
    $("#bonusSelect").hide();
    $("#bonusInput").show();
  }
}

function updateRadio(e)
{
  if ($(e).children()[0].value == -1) {
    $("#bonusInput").hide();
    $("#bonusSelect").show();
    $("#bonusSelect").val(0);
    $("#bonusSelect").attr('disabled', true);
  } else {
    $("#bonusInput").hide();
    $("#bonusSelect").show();
    $("#bonusSelect").attr('disabled', false);
  }
}

function checkBonus()
{
  if ($("#modalAmount").val() <= 0) {
    $("#invalidAmount").text("เกิดข้อผิดพลาด ตัวเลขต้องมากกว่า 0");
  } else if ($("#bonusInput").val() < 0) {
    $("#invalidBonus").text("เกิดข้อผิดพลาด ตัวเลขต้องมากกว่าหรือเท่ากับ 0");
  } else {
    topup();
    $("#modalAmount").val("");
  }
}

function topup()
{
  let response = '';
  let id = $("#modalRefresh").attr("name");
  let amount = $("#modalAmount").val() * $("input:checked").val();
  let bonus = $("#bonusSelect").val();
  let user = getCookie('user');
  if (bonus == -1) {
    bonus = $("#bonusInput").val();
  }
  let xmlhttp = new XMLHttpRequest();
  xmlhttp.onreadystatechange = function () {
    if (this.readyState == 4 && this.status == 200) {
      response =this.responseText;
      alert(response);
      $("#topupModal").modal('toggle');
      updateUser();
    }
  };
  xmlhttp.open("POST", "../dist/ajax/topup.php", true);
  xmlhttp.setRequestHeader('Content-type', 'application/x-www-form-urlencoded');
  xmlhttp.send("&id=" + id + "&amount=" + amount + "&bonus=" + bonus + "&user=" + user);
}