<?php
namespace Koob\BaccaratBundle\Controller;

use Koob\InterfaceBundle\BaccaratInterface;
use Koob\InterfaceBundle\DatabaseInterface;
use Koob\GameBundle\Controller\GameController;
use Koob\BaccaratBundle\Model\FunctionModel;

class FunctionController extends GameController implements BaccaratInterface
{
	protected $func;

	function __construct($model = null)
	{
		$model = empty($model) ? new FunctionModel : $model;
		$this->func = $model;
		$this->game = $model;
	}

	public function rebuildBaccarat(DatabaseInterface $con)
	{
		return $this->func->rebuildBaccarat($con);
	}

	public function wage(DatabaseInterface $con, $text)
	{
		$allowFirstCharecters = [1, 2, 3, 4, 5];
		if (in_array($text[0], $allowFirstCharecters)) {
			return $this->func->wage($con, $text);
		} else {
			return;
		}
	}

	public function unWage(DatabaseInterface $con, $text)
	{
		return $this->func->unWage($con, $text);
	}

	public function unWageAll(DatabaseInterface $con)
	{
		return $this->func->unWageAll($con);
	}

	public function check()
	{
		return $this->func->check();
	}

	public function checkAll(DatabaseInterface $con)
	{
		return $this->func->checkAll($con);
	}

	public function openGame(DatabaseInterface $con, $resetTime)
	{
		return $this->func->openGame($con, $resetTime);
	}

	public function openRound(DatabaseInterface $con, $openMessage)
	{
		return $this->func->openRound($con, $openMessage);
	}

	public function closeRound(DatabaseInterface $con, $closeMessage)
	{
		return $this->func->closeRound($con, $closeMessage);
	}

	public function restRound(DatabaseInterface $con, $resetTime)
	{
		return $this->func->restRound($con, $resetTime);
	}

	public function closeGame(DatabaseInterface $con, $resetTime)
	{
		return $this->func->closeGame($con, $resetTime);
	}

	public function saveResult(DatabaseInterface $con, $text)
	{
		return $this->func->saveResult($con, $text);
	}

	public function submit(DatabaseInterface $con)
	{
		return $this->func->submit($con);
	}

	public function setup(DatabaseInterface $con, $admins, $force)
	{
		return $this->func->setup($con, $admins, $force);
	}
}