<?php
namespace Koob\DatabaseBundle\Controller;

use Koob\InterfaceBundle\DatabaseInterface;
use Koob\DatabaseBundle\Model\DatabaseModel;

Class DatabaseController implements DatabaseInterface
{
	protected $con;

	function __construct($model = null, $storage = null)
	{
		$model = empty($model) ? new DatabaseModel($storage) : $model;
		$this->con = $model;
	}

	public function setHost($host)
	{
		$this->con->setHost($host);
		return $this;
	}

	public function getHost()
	{
		return $this->con->getHost();
	}

	public function setUser($user)
	{
		$this->con->setUser($user);
		return $this;
	}

	public function getUser()
	{
		return $this->con->getUser();
	}

	public function setPass($pass)
	{
		$this->con->setPass($pass);
		return $this;
	}

	public function getPass()
	{
		return $this->con->getPass();
	}

	public function setDatabase($database)
	{
		$this->con->setDatabase($database);
		return $this;
	}

	public function getDatabase()
	{
		return $this->con->getDatabase();
	}

	public function startQuery()
	{
		$this->con->startQuery();
		return $this;
	}

	public function create($creates = null)
	{
		$this->con->create($creates);
		return $this;
	}

	public function select($selects)
	{
		$this->con->select($selects);
		return $this;
	}

	public function update($updates)
	{
		$this->con->update($updates);
		return $this;
	}

	public function insert($inserts)
	{
		$this->con->insert($inserts);
		return $this;
	}

	public function drop()
	{
		$this->con->drop();
		return $this;
	}

	public function delete()
	{
		$this->con->delete();
		return $this;
	}

	public function from($table, $database = null)
	{
		$this->con->from($table, $database);
		return $this;
	}

	public function set($table, $database = null)
	{
		$this->con->set($table, $database);
		return $this;
	}

	public function into($table, $database = null)
	{
		$this->con->into($table, $database);
		return $this;
	}

	public function database($database)
	{
		$this->con->database($database);
		return $this;
	}

	public function table($table, $database = null)
	{
		$this->con->table($table, $database);
		return $this;
	}

	public function where($where)
	{
		$this->con->where($where);
		return $this;
	}

	public function and($and)
	{
		$this->con->and($and);
		return $this;
	}

	public function or($or)
	{
		$this->con->or($or);
		return $this;
	}

	public function like($like)
	{
		$this->con->like($like);
		return $this;
	}

	public function build()
	{
		$this->con->build();
		return $this;
	}

	public function query(bool $isReturnBool = false)
	{
		$return = $this->con->query($isReturnBool);
		return $isReturnBool ? $return : $this;
	}

	public function fetchAssoc(bool $isOneArray = false)
	{
		return $this->con->fetchAssoc($isOneArray);
	}

	public function getSql()
	{
		return $this->con->getSql();
	}

	public function close()
	{
		$this->con->close();
		return $this;
	}
}