<?php
namespace Koob\DatabaseBundle\Model;

use Koob\InterfaceBundle\DatabaseInterface;
use Koob\DatabaseBundle\Storage\DatabaseStorage;

Class DatabaseModel implements DatabaseInterface
{
	protected $con;

	function __construct($storage = null)
	{
		$storage = empty($storage) ? new DatabaseStorage : $storage;
		$this->con = $storage;
	}

	public function setHost($host)
	{
		$this->con->setHost($host);
	}

	public function getHost()
	{
		return $this->con->getHost();
	}

	public function setUser($user)
	{
		$this->con->setUser($user);
	}

	public function getUser()
	{
		return $this->con->getUser();
	}

	public function setPass($pass)
	{
		$this->con->setPass($pass);
	}

	public function getPass()
	{
		return $this->con->getPass();
	}

	public function setDatabase($database)
	{
		$this->con->setDatabase($database);
	}

	public function getDatabase()
	{
		return $this->con->getDatabase();
	}

	public function startQuery()
	{
		$this->con->StartQuery();
	}

	public function create($creates = null)
	{
		$this->con->method('create');
		if (!empty($creates)) {
			$create = "\nid INT UNSIGNED AUTO_INCREMENT PRIMARY KEY";
			foreach ((array) $creates as $field => $type)
			{
				$create .= ",\n$field $type\n";
			}
		}
		$this->con->create(['create' => $create]);
	}

	public function select($selects)
	{
		$this->con->method('select');
		foreach ((array) $selects as $varField)
		{
			if (empty($select)) {
				$select = $varField;
			} else {
				$select .= ", $varField";
			}
		}
		$this->con->select(['select' => $select]);
	}

	public function update($updates)
	{
		$this->con->method('update');
		foreach ((array) $updates as $varField => $varValue)
		{
			if (empty($update)) {
				$update = "$varField = '$varValue'";
			} else {
				$update .= ", $varField = '$varValue'";
			}
		}
		$this->con->update(['update' => $update]);
	}

	public function insert($inserts)
	{
		$this->con->method('insert');
		foreach ((array) $inserts as $varField => $varValue)
		{
			if (empty($insertField)) {
				$insertField = $varField;
			} else {
				$insertField .= ", $varField";
			}
			if (empty($insertValue)) {
				$insertValue = "'$varValue'";
			} else {
				$insertValue .= ", '$varValue'";
			}
		}
		$this->con->insert(['insertField' => $insertField, 'insertValue' => $insertValue]);
	}

	public function drop()
	{
		$this->con->method('drop');
		$this->con->drop();
	}

	public function delete()
	{
		$this->con->method('delete');
		$this->con->delete();
	}

	public function from($table, $database = null)
	{
		$this->con->from($table, $database);
	}

	public function set($table, $database = null)
	{
		$this->con->set($table, $database);
	}

	public function into($table, $database = null)
	{
		$this->con->into($table, $database);
	}

	public function database($database)
	{
		$this->con->database($database);
	}

	public function table($table, $database = null)
	{
		$this->con->table($table, $database);
	}

	public function where($where)
	{
		if (is_array($where)) {
			foreach ((array) $where as $varField => $varValue)
			{
				if (empty($whereAndString)) {
					$whereAndString = "$varField = '$varValue'";
				} else {
					$whereAndString .= " AND $varField = '$varValue'";
				}
			}
			$where = $whereAndString;
		}
		$this->con->where($where);
	}

	public function and($and)
	{
		$this->con->and($and);
	}

	public function or($or)
	{
		if (is_array($or)) {
			foreach ((array) $or as $varField => $varValue)
			{
				if (empty($whereAndString)) {
					$orAndString = "$varField = '$varValue'";
				} else {
					$orAndString .= " OR $varField = '$varValue'";
				}
			}
			$or = $orAndString;
		}
		$this->con->or($or);
	}

	public function like($like)
	{
		$this->con->like($like);
	}

	public function build()
	{
		$this->con->build();
	}

	public function query(bool $isReturnBool = false)
	{
		return $this->con->query($isReturnBool);
	}

	public function fetchAssoc(bool $isOneArray = false)
	{
		return $this->con->fetchAssoc($isOneArray);
	}

	public function getSql()
	{
		return $this->con->getSql();
	}

	public function close()
	{
		$this->con->close();
	}
}