<?php
namespace Koob\GameBundle\Controller;

use Koob\InterfaceBundle\GameInterface;
use Koob\InterfaceBundle\LineApiInterface;
use Koob\InterfaceBundle\DatabaseInterface;
use Koob\GameBundle\Model\GameModel;

class GameController implements GameInterface
{
	protected $game;

	function __construct($model = null)
	{
		$model = empty($model) ? new GameModel : $model;
		$this->game = $model;
	}

	public function rebuildMoney(DatabaseInterface $con)
	{
		return $this->game->rebuildMoney($con);
	}
	
	public function rebuildReportMoney(DatabaseInterface $con)
	{
		return $this->game->rebuildReportMoney($con);
	}

	public function rebuildLogin(DatabaseInterface $con)
	{
		return $this->game->rebuildLogin($con);
	}

	public function rebuildReport(DatabaseInterface $con, $table)
	{
		return $this->game->rebuildReport($con, $table);
	}

	public function rebuildAllReport(DatabaseInterface $con, $table)
	{
		return $this->game->rebuildAllReport($con, $table);
	}

	public function getData(DatabaseInterface $con, $table, $userId)
	{
		return $this->game->getData($con, $table, $userId);
	}

	public function getApi(LineApiInterface $api, $ids)
	{
		return $this->game->getApi($api, $ids);
	}

	public function insert(DatabaseInterface $con, $table, $extraInserts = [])
	{
		return $this->game->insert($con, $table, $extraInserts);
	}

	public function report(DatabaseInterface $con, $table, $reports)
	{
		return $this->game->report($con, $table, $reports);
	}

	public function reportAll(DatabaseInterface $con, $table, $reports)
	{
		return $this->game->reportAll($con, $table, $reports);
	}

	public function resultOpen(DatabaseInterface $con, $table, $game, $resetTime)
	{
		return $this->game->resultOpen($con, $table, $game, $resetTime);
	}

	public function resultRest(DatabaseInterface $con, $table, $game, $bigLap, $resetTime, $startTime = 0)
	{
		return $this->game->resultRest($con, $table, $game, $bigLap, $resetTime, $startTime);
	}

	public function resultClose(DatabaseInterface $con, $table, $game, $resetTime)
	{
		return $this->game->resultClose($con, $table, $game, $resetTime);
	}

	public function withdraw(DatabaseInterface $con, $table, $text)
	{
		return $this->game->withdraw($con, $table, $text);
	}

	public function confirmWithdraw(DatabaseInterface $con, $table, $text)
	{
		return $this->game->confirmWithdraw($con, $table, $text);
	}

	public function showScore(DatabaseInterface $con, $table)
	{
		return $this->game->showScore($con, $table);
	}

	public function changeAttr(DatabaseInterface $con, $name, $attr)
	{
		return $this->game->changeAttr($con, $name, $attr);
	}

	public function saveRollBack(DatabaseInterface $con, $database)
	{
		return $this->game->saveRollBack($con, $database);
	}

	public function deleteAllMoney(DatabaseInterface $con, $database, $type = null)
	{
		return $this->game->deleteAllMoney($con, $database, $type);
	}

	public function setAdmin(DatabaseInterface $con, $table, $admins, $adminId, $status)
	{
		return $this->game->setAdmin($con, $table, $admins, $adminId, $status);
	}

	public function checkId(DatabaseInterface $con, $table, $admins, $targetNames)
	{
		return $this->game->checkId($con, $table, $admins, $targetNames);
	}

	public function checkCount(DatabaseInterface $con, $table, $tags)
	{
		return $this->game->checkCount($con, $table, $tags);
	}

	public function checkMoney(DatabaseInterface $con, $table, $doNotSendUsers = null)
	{
		return $this->game->checkMoney($con, $table, $doNotSendUsers);
	}

	public function checkAllMoney(DatabaseInterface $con, $table, $isReportAll = false)
	{
		return $this->game->checkAllMoney($con, $table, $isReportAll);
	}

	public function checkPeople(DatabaseInterface $con, $table, $isReturnOnlyNumber = false)
	{
		return $this->game->checkPeople($con, $table, $isReturnOnlyNumber);
	}

	public function fixMoney(DatabaseInterface $con, $table, $text)
	{
		return $this->game->fixMoney($con, $table, $text);
	}

	public function flexMessage($text, $size, $type)
	{
		return $this->game->flexMessage($text, $size, $type);
	}

	public function status(DatabaseInterface $con, $admins)
	{
		return $this->game->status($con, $admins);
	}

	public function test($text)
	{
		return $this->game->test($text);
	}

	public function codename($name)
	{
		return $this->game->codename($name);
	}

	public function fix_array(&$inputs, $paths, $value)
	{
		return $this->game->fix_array($inputs, $paths, $value);
	}
}