<?php
namespace Koob\GameBundle\Model;

use Koob\InterfaceBundle\GameInterface;
use Koob\InterfaceBundle\LineApiInterface;
use Koob\InterfaceBundle\DatabaseInterface;

class GameModel implements GameInterface
{
	protected $id;

	protected $name;

	protected $tag;

	protected $net;

	protected $bonus;

	protected $userId;

	protected $admin;

	protected $scores;

	protected $result;

	protected $play;

	protected $datas;

	protected $contents;

	protected $deposite;

	public function rebuildMoney(DatabaseInterface $con)
	{
		$con->startQuery()
			->drop()
			->table('money', 'money')
			->build()
			->query()
			->close();

		$con->startQuery()
			->create([
				'name'     => 'VARCHAR(255)',
				'userId'   => 'VARCHAR(255) UNIQUE',
				'net'      => 'INT',
				'admin'    => 'VARCHAR(255)',
				'tag'      => 'INT',
				'count'    => 'INT',
				'wage'     => 'INT',
				'bonus'    => 'INT',
				'rollBack' => 'VARCHAR(255)',
				'deposite' => 'INT',
			])
			->table('money', 'money')
			->build()
			->query()
			->close();
	}

	public function rebuildReportMoney(DatabaseInterface $con)
	{
		$con->startQuery()
			->drop()
			->table('reportMoney', 'money')
			->build()
			->query()
			->close();

		$con->startQuery()
			->create([
				'amount' => 'INT',
				'bonus'  => 'INT',
				'time'   => 'VARCHAR(255)',
				'date'   => 'VARCHAR(255)',
				'month'  => 'VARCHAR(255)',
				'year'   => 'VARCHAR(255)',
				'user'   => 'VARCHAR(255)',
				'game'   => 'VARCHAR(255)',
			])
			->table('reportMoney', 'money')
			->build()
			->query()
			->close();
	}

	public function rebuildLogin(DatabaseInterface $con)
	{
		$con->startQuery()
			->drop()
			->table('login')
			->build()
			->query()
			->close();

		$con->startQuery()
			->create([
				'name' => 'VARCHAR(255)',
				'user'    => 'VARCHAR(255) UNIQUE',
				'pass'    => 'VARCHAR(255)',
			])
			->table('login')
			->build()
			->query()
			->close();
		
		$con->startQuery()
			->insert([
				'name' => '"admin"',
				'user' => 'root',
				'pass' => '70efb8d166cf4936380cdd32d1d78eecd8a6265372661e01c8ab60f6a5cac114',	
			])
			->into('login')
			->build()
			->query()
			->close();
	}

	public function rebuildReport(DatabaseInterface $con, $table)
	{
		$table = 'report'.ucfirst($table);

		$con->startQuery()
			->drop()
			->table($table)
			->build()
			->query()
			->close();

		$con->startQuery()
			->create([
				'game'     => 'VARCHAR(255)',
				'bigLap'   => 'VARCHAR(255)',
				'lap'      => 'VARCHAR(255)',
				'income'   => 'VARCHAR(255)',
				'outcome'  => 'VARCHAR(255)',
				'fix'      => 'VARCHAR(255)',
			])
			->table($table)
			->build()
			->query()
			->close();
	}

	public function rebuildAllReport(DatabaseInterface $con, $table)
	{
		$table = 'reportAll'.ucfirst($table);

		$con->startQuery()
			->drop()
			->table($table)
			->build()
			->query()
			->close();

		$con->startQuery()
			->create([
				'date'     => 'VARCHAR(255)',
				'week'     => 'VARCHAR(255)',
				'month'    => 'VARCHAR(255)',
				'year'     => 'VARCHAR(255)',
				'deposite' => 'VARCHAR(255)',
				'withdraw' => 'VARCHAR(255)',
				'conclude' => 'VARCHAR(255)',
				'fix'      => 'VARCHAR(255)',
				'game'     => 'VARCHAR(255)',
			])
			->table($table)
			->build()
			->query()
			->close();
	}

	public function getData(DatabaseInterface $con, $table, $userId)
	{
		$receiveDatabases = $con->startQuery()
				->select(['id', 'content', 'admin', 'result'])
				->from($table)
				->where(['id' => 1])
				->or(['userId' => $userId])
				->build()
				->query()
				->fetchAssoc();
		$con->close();
		$id = $receiveDatabases[1]['id'];
		$data = $receiveDatabases[0]['content'];
		$data = str_replace("\n", "enter", $data);
		$content = $receiveDatabases[1]['content'];
		$result = $receiveDatabases[0]['result'];
		$score = $receiveDatabases[0]['admin'];
		$this->admin = $receiveDatabases[1]['admin'];
		$this->scores = json_decode($score);
		$this->datas = json_decode($data, 1);
		$this->contents = json_decode($content, 1);
		$this->results = json_decode($result, 1);
		$this->userResult = $receiveDatabases[1]['result'];

		$receiveDatabases = $con->startQuery()
				->select(['id', 'net', 'tag', 'bonus', 'deposite'])
				->from('money', 'money')
				->where(['userId' => $userId])
				->build()
				->query()
				->fetchAssoc();
		$con->close();
		$this->id = $receiveDatabases[0]['id'];
		$this->tag = $receiveDatabases[0]['tag'];
		$this->net = (int) $receiveDatabases[0]['net'];
		$this->bonus = (int) $receiveDatabases[0]['bonus'];
		$this->deposite = (int) $receiveDatabases[0]['deposite'];

		$this->datas['deli'] = empty($this->datas['deli']) ? '-' : $this->datas['deli'];
		if (empty($this->datas['allDeli']))
			$this->datas['allDeli'] = ',';
		else if ($this->datas['allDeli'] == "enter") {
			$this->datas['allDeli'] = "\n";
		}

		return empty($id) ? null : $this->id;
	}

	public function getApi(LineApiInterface $api, $ids)
	{
		['userId' => $userId,'roomId' => $roomId,'groupId' => $groupId] = $ids;
		$receiveApis = $api->startApi()
				->setRoomId($roomId)
				->setGroupId($groupId)
				->get($userId);
		$api->close();
		$this->name = $receiveApis['displayName'];
		$this->userId = $receiveApis['userId'];
		return $this->userId;
	}

	public function insert(DatabaseInterface $con, $table, $extraInserts = [])
	{
		$inserts = [
			'name'    => $this->codeName($this->name),
			'content' => '{}',
			'userId'  => $this->userId,
		];
		foreach ((array) $extraInserts as $field => $value)
		{
			$inserts[$field] = $value;
		}
		$test = $con->startQuery()
			->select(['userId'])
			->from($table)
			->where(['userId' => $this->userId])
			->build()
			->query()
			->fetchAssoc()[0]['userId'];
		$con->close();
		if (empty($test)) {
			$con->startQuery()
				->insert($inserts)
				->into($table)
				->build()
				->query()
				->close();
		}
		if (empty($this->id)) {
			$con->startQuery()
				->insert([
					'name'    => $this->codeName($this->name),
					'userId'  => $this->userId,
					'net'     => 0,
				])
				->into('money', 'money')
				->build()
				->query()
				->close();

			$resultRows = $con->startQuery()
				->select(['id'])
				->from('money', 'money')
				->where(['userId' => $this->userId])
				->build()
				->query()
				->fetchAssoc();
			$con->close();
			$this->id = $resultRows[0]['id'];
		}
		return $this->id;
	}

	public function report(DatabaseInterface $con, $table, $reports)
	{
		$reportTable = 'report'.ucfirst($table);
		$return = $con->startQuery()
			->insert($reports)
			->into($reportTable)
			->build()
			->query(true);
		$con->close();
		return $return;
	}

	public function reportAll(DatabaseInterface $con, $table, $reports)
	{
		$reportTable = 'reportAll'.ucfirst($table);
		$return = $con->startQuery()
			->insert($reports)
			->into($reportTable)
			->build()
			->query(true);
		$con->close();
		return $return;
	}

	public function resultOpen(DatabaseInterface $con, $table, $game, $resetTime)
	{
		date_default_timezone_set('Asia/Bangkok');
		$date = date('H') < $resetTime ? date('j', strtotime("-1 days")) : date('j');
		$month = date('H') < $resetTime ? date('n', strtotime("-1 days")) : date('n');
		$year = date('H') < $resetTime ? date('Y', strtotime("-1 days")) : date('Y');

		$resultRows = $con->startQuery()
			->select(['amount', 'bonus'])
			->from('reportMoney', 'money')
			->where(['date' => $date, 'month' => $month, 'year' => $year])
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		foreach ((array) $resultRows as $rows)
		{
			$remaining += $rows['amount'];
			if ($rows['amount'] > 0) {
				$deposite += $rows['amount'];
			} else {
				$withdraw += $rows['amount'];
			}
			$bonus += $rows['bonus'];
		}
		$replyText .= "-------------------------";
		$replyText .= "\r\nเริ่มเกมที่ #$game";
		$replyText .= "\r\nเวลา ".date('H.i');
		$replyText .= "\r\n";
		$replyText .= "\r\nฝาก = ". (int) $deposite;
		$replyText .= "\r\nถอน = ". (int) $withdraw;
		$replyText .= "\r\nเครดิต = ". (int) $remaining;
		$replyText .= "\r\nโบนัส = ". (int) $bonus;
		$replyText .= "\r\n-------------------------";
		return $replyText;
	}

	public function resultRest(DatabaseInterface $con, $table, $game, $bigLap, $resetTime, $startTime = 0)
	{
		date_default_timezone_set('Asia/Bangkok');
		$reportTable = 'report'.ucfirst($table);
		$resultRows = $con->startQuery()
			->select(['income', 'outcome', 'fix'])
			->from($reportTable)
			->where(['game' => $game, 'bigLap' => $bigLap])
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		foreach ((array) $resultRows as $rows) {
			$income  += (int) $rows['income'];
			$outcome += (int) $rows['outcome'];
			$fix     += (int) $rows['fix'];
		}

		$time = date('H.i');
		$date = date('H') < $resetTime ? date('j', strtotime("-1 days")) : date('j');
		$month = date('H') < $resetTime ? date('n', strtotime("-1 days")) : date('n');
		$year = date('H') < $resetTime ? date('Y', strtotime("-1 days")) : date('Y');
		$con->startQuery()
			->select(['amount', 'bonus'])
			->from('reportMoney', 'money');
		if ($time < $resetTime) {
			$con->where("(date=$date OR date=".date('j').") AND (month=$month OR month=".date('n').") AND (year=$year OR year=".date('Y').")");
		} else {
			$con->where(['date' => $date, 'month' => $month, 'year' => $year])
				->and("$startTime<time AND time<$time");
		}
		$resultRows = $con->build()
			->query()
			->fetchAssoc();
		$con->close();
		foreach ((array) $resultRows as $rows)
		{
			if ($rows['amount'] > 0) {
				$deposite += $rows['amount'];
			} else {
				$withdraw += $rows['amount'];
			}
			$bonus    += (int) $rows['bonus'];
		}

		$result = $income - $outcome - $fix;
		$result = ($result>0) ? "+$result" : $result ;

		$replyText = "สรูปรอบที่ #". (int) $bigLap;
		$replyText .= "\r\n-------------------------";
		$replyText .= "\r\nสรุปรอบที่ #{$game}-{$bigLap}";
		$replyText .= "\r\n";
		$replyText .= "\r\nเวลา ".date('H.i');
		$replyText .= "\r\nเจ้ารับ = ". (int) $income;
		$replyText .= "\r\nเจ้าจ่าย = ". (int) $outcome;
		$replyText .= "\r\nผลลัพธ์ = ". (int) $result;
		$replyText .= "\r\n";
		$replyText .= "\r\nฝาก = ". (int) $deposite;
		$replyText .= "\r\nโบนัส = ". (int) $bonus;
		$replyText .= "\r\nถอน = ". (int) $withdraw;
		$replyText .= "\r\nแก้ไขยอด = ". (int) $fix;
		$replyText .= "\r\n-------------------------";
		return $replyText;
	}

	public function resultClose(DatabaseInterface $con, $table, $game, $resetTime)
	{
		date_default_timezone_set('Asia/Bangkok');
		$reportTable = 'report'.ucfirst($table);
		$resultRows = $con->startQuery()
			->select(['income', 'outcome', 'fix'])
			->from($reportTable)
			->where(['game' => $game])
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		foreach ((array) $resultRows as $rows) {
			$income += (int) $rows['income'];
			$outcome += (int) $rows['outcome'];
			$fix += (int) $rows['fix'];
		}

		$date = date('H') < $resetTime ? date('j', strtotime("-1 days")) : date('j');
		$month = date('H') < $resetTime ? date('n', strtotime("-1 days")) : date('n');
		$year = date('H') < $resetTime ? date('Y', strtotime("-1 days")) : date('Y');
		$resultRows = $con->startQuery()
			->select(['amount', 'bonus'])
			->from('reportMoney', 'money')
			->where(['date' => $date, 'month' => $month, 'year' => $year])
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		foreach ((array) $resultRows as $rows)
		{
			if ($rows['amount'] > 0) {
				$deposite += $rows['amount'];
			} else {
				$withdraw += $rows['amount'];
			}
			$bonus    += (int) $rows['bonus'];
		}

		$result = $income-$outcome-$fix;
		$result = ($result>0) ? "+$result" : $result ;

		$profit = $deposite+$withdraw;
		$proOrLoss = ($profit>0) ? 'กำไร' : 'ขาดทุน';

		$replyText .= "-------------------------";
		$replyText .= "\r\nสรุปเกมที่ #{$game}";
		$replyText .= "\r\nเวลา ".date('H.i');
		$replyText .= "\r\n";
		$replyText .= "\r\nเจ้ารับ = ". (int) $income;
		$replyText .= "\r\nเจ้าจ่าย = ". (int) $outcome;
		$replyText .= "\r\nผลลัพธ์ = ". (int) $result;
		$replyText .= "\r\n";
		$replyText .= "\r\nฝาก = ". (int) $deposite;
		$replyText .= "\r\nถอน = ". (int) $withdraw;
		$replyText .= "\r\nโบนัส = ". (int) $bonus;
		$replyText .= "\r\n$proOrLoss = ". (int) $profit;
		$replyText .= "\r\nแก้ไขยอด = ". (int) $fix;
		$replyText .= "\r\n-------------------------";

		$date = date('j');
		$week = date('W');
		$month = date('n');
		$year = date('Y') + 543;
		$reports = [
			'date' => $date,
			'week' => $week,
			'month' => $month,
			'year' => $year,
			'deposite' => $deposite,
			'withdraw' => $withdraw,
			'conclude' => $profit,
			'fix' => $fix,
			'game' => $game,
		];
		$this->reportAll($con, $table, $reports);
		return $replyText;
	}

	public function result(DatabaseInterface $con, $database)
	{
		if (method_exists($this, "spacialResult")) {
			return $this->spacialResult($con);
		}
		if (!in_array($this->admin, ['yes', 'super'])) {
			return;
		}
		if (method_exists($this, "saveScore")) {
			$this->saveScore($con);
		}
		$resultRows = $con->startQuery()
			->select(['name', 'userId', 'content'])
			->from($database)
			->where('id > 1')
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		$whereText = $con->select(['userId'])
			->from($database)
			->where('id > 1')
			->build()
			->getSql();
		$allPlayerRows = $con->startQuery()
			->select(['id', 'userId', 'net', 'count', 'wage', 'bonus'])
			->from('money', 'money')
			->where("userId in ($whereText)")
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		foreach ((array) $allPlayerRows as $rows)
		{
			$idRows[$rows['userId']] = $rows['id'];
			$moneyRows[$rows['userId']] = $rows['net'];
			$countRows[$rows['userId']] = (int) $rows['count']+1;
			$wageRows[$rows['userId']] = (int) $rows['wage'];
			$bonusRows[$rows['userId']] = (int) $rows['bonus'];
		}
		[$rewards, $results, $reduces] = $this->rule();
		$replyTexts = $this->flexMessage([
			'altText' => "สรุปรอบย่อยที่ #".$this->datas['lap'],
			'header' => "สรุปรอบย่อยที่ #".$this->datas['lap'],
		], 'xs');
		$normalReply = "สรุปรอบย่อยที่ #".$this->datas['lap'];
		if (method_exists($this, "beforeResultLoop")) {
			$resultRows = $this->beforeResultLoop($resultRows, $results);
		}
		foreach ((array) $resultRows as $rows)
		{
			unset($allWageNet, $money);
			$contents = json_decode($rows['content'], 1);
			$userNet = $moneyRows[$rows['userId']];
			$userBonus = $bonusRows[$rows['userId']];
			$rollBacks = [
				'net'   => $userNet,
				'count' => $countRows[$rows['userId']]-1,
				'wage'  => $wageRows[$rows['userId']],
				'bonus' => $userBonus,
			];
			foreach ((array) $contents as $wage)
			{
				$allWageNet += (int) $wage;
			}
			if (empty($allWageNet)) {
				continue;
			}
			foreach ((array) $contents as $type => $wageNet)
			{
				if (in_array((string) $type, (array) $results)) {
					$money += (int) ($wageNet*$rewards[$type]);
					$outcome += (int) ($wageNet*$rewards[$type]);
				} else if (in_array((string) $type, array_keys((array) $reduces))) {
					$money += (int) $wageNet*$reduces[$type];
					if ($money > 0) {
						$outcome += (int) $wageNet*$reduces[$type];
					} else {
						$income += (int) $wageNet*$reduces[$type];
					}
				} else {
					$money -= (int) $wageNet;
					$income += (int) $wageNet;
				}
				$wageRows[$rows['userId']] += $wageNet;
			}
			if ($userBonus > 0 && $money < 0) {
				$userBonus += $money;
			} else {
				$userNet += $money;
			}
			if ($userBonus <= 0) {
				$userNet += $userBonus;
				$userBonus = 0;
			}
			if ($money > 0) {
				$eachReply = "+$money";
			} else if ($money == 0) {
				$eachReply = "+0";
			} else {
				$eachReply = "$money";
			}
			$replyTexts = $this->flexMessage([
				'old' => $replyTexts,
				'body' => [
					[
						$idRows[$rows['userId']].")".json_decode($rows['name'], 1),
						$eachReply,
						$userNet,
						"💸".(int) $userBonus,
					],
				],
			], 'xs');
			$normalReply .= "\r\n".$idRows[$rows['userId']].")".json_decode($rows['name'], 1).$eachReply."=".$userNet."💸".(int) $userBonus;
			$rollBack = json_encode($rollBacks);
			$con->startQuery()
				->update([
					'net'      => $userNet,
					'count'    => $countRows[$rows['userId']],
					'wage'     => $wageRows[$rows['userId']],
					'bonus'    => $userBonus,
					'rollBack' => $rollBack,
				])
				->set('money', 'money')
				->where(['userId' => $rows['userId']])
				->build()
				->query()
				->close();
			$con->startQuery()
				->update(['content' => '{}'])
				->set($database)
				->where(['userId' => $rows['userId']])
				->build()
				->query()
				->close();
		}
		$reports = [
			'game'    => $this->datas['game'],
			'bigLap'  => $this->datas['bigLap'],
			'lap'     => $this->datas['lap'],
			'income'  => $income,
			'outcome' => $outcome,
		];
		$this->report($con, $database, $reports);
		$replyTexts['normalReply'] = $normalReply;
		return $replyTexts;
	}

	public function withdraw(DatabaseInterface $con, $table, $text)
	{
		if ($this->datas['status'] == 'open') {
			return "ถอนไม่ได้ รอปิดรอบก่อน";
		}
		if ($this->datas['status'] == 'check') {
			return "ถอนไมได้ สรุปรอบก่อน";
		}
		$text = preg_replace("/\s+/", " ", $text);
		$texts = explode(" ", $text);
		if (empty($texts[count($texts)-1])) {
			unset($texts[count($texts)-1]);
		}
		if (count($texts) < 5) {
			return "คำสั่งไม่ครบ (@wd ยอดเงิน เลขบัญชี ชื่อธนาคาร ชื่อบัญชี)";
		}
		if (!is_numeric($texts[1]) || $texts[1] <= 0 || stripos((string) $texts[1], '.') !== false) {
			return "ยอดเงินผิดพลาด ต้องเป็นจำนวนเต็ม";
		}
		if ($texts[1] > $this->net) {
			return "ยอดเงินไม่เพียงพอ";
		}
		$withdrawMoney = (int) $texts[1];
		$bankNo = $texts[2];
		$bankName = $texts[3];
		unset($texts[0], $texts[1], $texts[2], $texts[3]);
		$name = implode(" ", $texts);
		$replyText = $this->flexMessage([
				'altText' => "ยืนยันแจ้งถอน $this->name",
				'header' => "ยืนยันแจ้งถอน $this->name",
				'body' => [
					[
						"เลขบัญชี",
						$bankNo,
					],[
						"ธนาคาร",
						$bankName,
					],[
						"ชื่อ",
						$name,
					],[
						"จำนวนเงิน",
						$withdrawMoney,
					],
				],
				'button' => [
					[
						'type' => 'message',
						'label' => 'ยืนยัน',
						'text' => '#WDyes',
					],[
						'type' => 'message',
						'label' => 'ยกเลิก',
						'text' => '#WDcancel',
					],
						
				],
		]);
		$datas['withdraw'] = [
			"bankNo" => $bankNo,
			"bankName" => $bankName,
			"name" => $name,
			"withdrawMoney" => $withdrawMoney,
		];
		$data = $this->codename($datas);
		$con->startQuery()
			->update(['result' => $data])
			->set($this->database)
			->where(['userId' => $this->userId])
			->build()
			->query()
			->close();
		return $replyText;
	}

	public function confirmWithdraw(DatabaseInterface $con, $table, $text)
	{
		if (empty(json_decode($this->userResult, 1)['withdraw'])) {
			return 	"คำสั่งผิด (@wd ยอดเงิน เลขบัญชี ชื่อธนาคาร ชื่อบัญชี)";
		}
		if ($text == '#WDyes') {
			[
				"bankNo" => $bankNo,
				"bankName" => $bankName,
				"name" => $name,
				"withdrawMoney" => $withdrawMoney,
			] = json_decode($this->userResult, 1)['withdraw'];
			$reportText = $this->id.")".$this->name."\r\nเลขบัญชี ".$bankNo."\r\nธนาคาร ".$bankName."\r\nจำนวนเงิน ".$withdrawMoney."\r\nชื่อ ".$name;
			$this->net -= $withdrawMoney;
			$con->startQuery()
				->update(['result' => null])
				->set($this->database)
				->where(['userId' => $this->userId])
				->build()
				->query()
				->close();
			$con->startQuery()
				->update(['net' => $this->net])
				->set('money', 'money')
				->where(['userId' => $this->userId])
				->build()
				->query()
				->close();
			$con->startQuery()
				->insert([
					'amount' => -$withdrawMoney,
					'bonus'  => 0,
					'time'   => date('H:i'),
					'date'   => date('j'),
					'month'  => date('n'),
					'year'   => date('Y'),
					'game'   => $this->database.$this->datas['game'],
				])
				->into('reportMoney', 'money')
				->build()
				->query()
				->close();
			$replyTexts['reply'] = "ถอน $withdrawMoney คงเหลือ $this->net";
			$replyTexts['report'] = $reportText;
		} elseif ($text == '#WDcancel') {
			$replyTexts['reply'] = "ยกเลิกการถอน";
			$con->startQuery()
				->update(['result' => null])
				->set($this->database)
				->where(['userId' => $this->userId])
				->build()
				->query()
				->close();
		}
		return $replyTexts;
	}

	public function showScore(DatabaseInterface $con, $table)
	{
		if (!in_array($this->admin, ['yes', 'super'])) {
			return;
		}
		if ($this->datas['sc'] == "no") {
			return;
		}
		if (empty($this->scores)) {
			return 'ไม่มีสกอร์';
		}
		if ($table == 'baccarat') {
			$header = '1🔵 2🔴 3⚪';
		} else if ($table == 'tigerDragon') {
			$header = '1🔵 2🔴 3⚪ 4⚫';
		} else {
			$header = '1🔵 2🔴 3⚪ 4⚫';
		}
		$count = 0;
		$bubble = 0;
		$row = -1;
		$olds = [0,1,2,3,4,5];
		if ($this->datas['showsc'] == 0) {
			$replyTexts = $this->flexMessage([
				'altText' => 'สรุปสกอร์',
				'header' => $header,
			]);
			foreach ((array) $this->scores as $score)
			{
				$count++;
				$text .= $score;
				if ($count >= 6) {
					$count = 0;
					$text .= "\r\n";
				}
			}
			$replyTexts = $this->flexMessage([
				'old' => $replyTexts,
				'body' => [
					[
						str_replace([0,1,2,3,4,5], ['','🔵','🔴','⚪','⚪','⚫'], $text),
					],
				],
			]);
		} else if ($this->datas['showsc'] == 1) {
			$replyTexts = $this->flexMessage([
				'altText' => 'สรุปสกอร์',
				'header' => '1🔵 2🔴 3Ⓜ️⛔️ 4⚫',
			]);
			foreach ((array) $this->scores as $score)
			{
				if (strlen($bodys[$bubble][0]) == 10) {
					$bubble++;
					$row = -1;
					$olds = [0,1,2,3,4,5];
				}
				if (!in_array($score, $olds)) {
					$bodys[$bubble][0] .= $score;
					$row = 0;
				} else {
					$hole = '';
					$max = strlen($bodys[$bubble][0])-strlen($bodys[$bubble][++$row])-1;
					for ($i=0; $i<$max; $i++)
					{
						$hole .= '0';
					}
					$bodys[$bubble][$row] .= $hole.$score;
				}
				if (in_array($score, [1,3])) {
					$olds = [1,3,5];
				} else if (in_array($score, [2,4])) {
					$olds = [2,4,5];
				}
			}
			foreach ((array) $bodys as $n => $bubble)
			{
				unset($text);
				foreach ((array) $bubble as $body)
				{
					$text .= "$body\r\n";
				}
				$text = trim(str_replace([0,1,2,3,4,5], ['⬜','🔵','🔴','Ⓜ️','⛔️','⚫'], $text));
				$replyTexts = $this->flexMessage([
					'old' => $replyTexts,
					'body' => [
						[
							$text,
						],
					],
					'new' => $n,
				]);
			}
			foreach ($replyTexts['messages'][0]['contents']['contents'] as $n => $contents)
			{
				$replyTexts['messages'][0]['contents']['contents'][$n]['styles']['body'] = ['backgroundColor' => '#d0d0d0'];
			}
		}
		return $replyTexts;
	}

	public function changeAttr(DatabaseInterface $con, $name, $attr)
	{
		if (!in_array($this->admin, ['yes', 'super'])) {
			return;
		}
		if (is_numeric($attr) && $attr < 0) {
			$error = "ค่าที่ตั้งต้องมากกว่า 0";
		}
		if (!in_array($name, $this->attrs)) {
			$error = "คำสั่ง $name ผิดพลาด (มีเพียง ".implode(" ", $this->attrs).")";
		}
		if (empty($name)) {
			$error = "คำสั่ง มี ".implode(" ", $this->attrs);
		}
		$attrname = $attr;
		switch ($name) {
			case 'recc':
			case 'sc':
			case 'wage+':
			case '$':
			case 'jackpot':
			case 'report':
				if (!in_array($attr, ['yes', 'no']))
					$error = "ตั้งได้แค่ yes กับ no";
			break;

			case 'reply':
				if(!in_array($attr, ['yes', 'flex', 'no']))
					$error = "ตั้งได้แค่ yes, flex และ no";
			break;

			case 'min':
			case 'max':
			case 'setba':
			case 'player':
			case 'wage':
			case 'cp':
			case 'deng':
			case 'rule':
			case 'showsc':
				if (!is_numeric($attr))
					$error = "ตั้งได้แค่ตัวเลข";
			break;

			case 'depo':
			case 'allDepo':
			case 'percent':
				if (!is_numeric($attr) || 100 < $attr)
					$error = "ตั้งได้ตั้งแต่ 0-100";
			break;

			case 'rw':
				$attr = explode(',', $attr);
				foreach ((array) $attr as $a)
					if (stripos($a, '%')) {
						$a = substr($a, 0, -1);
					}
					if (!is_numeric($a) || $a < 0)
						$error = "ตั้งตั้งเป็นตัวเลข";
			break;
		}
		if (empty($error)) {
			$this->datas[$name] = $attr;
			$data = json_encode($this->datas);
			if (!empty($data)) {
				$con->startQuery()
					->update(['content' => $data])
					->set($this->database)
					->where(['id' => 1])
					->build()
					->query()
					->close();
				$replyText = "ปรับ $name เป็น $attrname";
				if (in_array($name, ['depo', 'allDepo', 'setba', 'percent']))
					$replyText .= "%";
				if (in_array($name, ['deng']))
					$replyText .= ' เท่า';
			} else {
				$replyText = "ผิดพลาด";
			}
		} else {
			$replyText = $error;
		}
		return $replyText;
	}

	public function saveRollBack(DatabaseInterface $con, $database)
	{
		if (!in_array($this->admin, ['yes', 'super']) || !in_array($this->datas['status'], ['close', 'check'])) {
			return;
		}
		$confirm = $con->startQuery()
			->select(['result', 'rollBack'])
			->from($database)
			->where(['id' => 1])
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		if (empty($confirm[0]['rollBack'])) {
			return;
		} else if (empty($confirm[0]['result'])) {
			$con->startQuery()
				->update(['result' => 'r'])
				->set($database)
				->where(['id' => 1])
				->build()
				->query()
				->close();
			$replyText = "พิมพ์ r อีกครั้งเพื่อยืนยันการย้อนกลับไปรอบก่อนหน้า";
		} else {
			$replyText = $this->rollBack($con, $database);
		}
		return $replyText;
	}

	public function rollBack(DatabaseInterface $con, $database)
	{
		$receiveDatabases = $con->startQuery()
			->select(['id', 'admin', 'rollBack'])
			->from($database)
			->where('rollBack IS NOT NULL')
			->and('rollBack != ""')
			->and('rollBack != "{}"')
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		if (!empty($receiveDatabases[0]['admin'])) {
			$score = substr($receiveDatabases[0]['admin'], 0, -3)."]";
			$con->startQuery()
				->update(['admin' => $score])
				->set($database)
				->where(['id' => 1])
				->build()
				->query()
				->close();
		}
		foreach ((array) $receiveDatabases as $rows)
		{
			$con->startQuery()
				->update(['content' => $rows['rollBack'], 'rollBack' => null])
				->set($database)
				->where(['id' => $rows['id']])
				->build()
				->query()
				->close();
		}
		$receiveDatabases = $con->startQuery()
			->select(['id', 'rollBack'])
			->from('money', 'money')
			->where('rollBack IS NOT NULL')
			->and('rollBack != ""')
			->and('rollBack != "{}"')
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		foreach ((array) $receiveDatabases as $rows)
		{
			$rollBacks = json_decode($rows['rollBack'], 1);
			$rollBacks = array_merge((array) $rollBacks, ['rollBack' => null]);
			$con->startQuery()
				->update($rollBacks)
				->set('money', 'money')
				->where(['id' => $rows['id']])
				->build()
				->query()
				->close();
		}
		$report = "report".ucfirst($database);
		$lastReport = $con->startQuery()
			->select('max(id) as id')
			->from($report)
			->build()
			->query()
			->fetchAssoc()[0]['id'];
		$con->close();
		$con->startQuery()
			->delete()
			->from($report)
			->where("id = $lastReport")
			->build()
			->query()
			->close();
		return 'ย้อนรอบเสร็จสิ้น';
	}

	public function deleteAllMoney(DatabaseInterface $con, $database, $type = null)
	{
		if (!in_array($this->admin, ['yes', 'super'])) {
			return;
		}
		if (!empty($type) && empty(json_decode($this->userResult, 1)['DAMconfirm'])) {
			return;
		}

		if ($type == '#DAMyes') {
			$replyText = "ลบยอดเสร็จสิ้น";
			$whereText = $con->select(['userId'])
				->from($database)
				->where('id > 1')
				->build()
				->getSql();
			$con->startQuery()
				->update(['net' => 0, 'tag' => 0, 'count' => 0, 'wage' => 0, 'bonus' => 0])
				->set('money', 'money')
				->where("userId in ($whereText)")
				->build()
				->query()
				->close();
		} else if ($type == '#DAMcancel') {
			$replyText = "ยกเลิกการลบยอด";
			$con->startQuery()
				->update(['result' => null])
				->set($this->database)
				->where(['userId' => $this->userId])
				->build()
				->query()
				->close();
		} else {
			$replyText = $this->flexMessage([
					'altText' => "ยืนยันลบยอดเงินทุกคน",
					'header' => "ยืนยันลบยอดเงินทุกคน",
					'button' => [
						[
							'type' => 'message',
							'label' => 'ยืนยัน',
							'text' => '#DAMyes',
						],[
							'type' => 'message',
							'label' => 'ยกเลิก',
							'text' => '#DAMcancel',
						],
					],
			]);
			$datas['DAMconfirm'] = 'yes';
			$data = $this->codename($datas);
			$con->startQuery()
				->update(['result' => $data])
				->set($this->database)
				->where(['userId' => $this->userId])
				->build()
				->query()
				->close();
		}

		return $replyText;
	}

	public function setAdmin(DatabaseInterface $con, $table, $admins, $adminId, $status)
	{
		if (!in_array($this->userId, $admins) && $this->admin != 'super') {
			return;
		}

		if (in_array($status, ['no', '0'])) {
			$adminStatus = null;
			$text = 'not admin';
		} else if (empty($status) || $status == 'yes') {
			$adminStatus = 'yes';
			$text = 'admin';
		} else if ($status == 'super') {
			$adminStatus = 'super';
			$text = 'super admin';
		} else {
			return "คุณไม่มีสิทธิ์ตั้ง admin";
		}
		$resultRows = $con->startQuery()
			->select(['userId', 'name'])
			->from('money', 'money')
			->where(['id' => $adminId])
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		$userId = $resultRows[0]['userId'];
		$name = json_decode($resultRows[0]['name'], 1);

		$queryBool = $con->startQuery()
			->update(['admin' => $adminStatus])
			->set($table)
			->where(['userId' => $userId])
			->build()
			->query(true);
		$con->close();

		$replyText = $queryBool ? "$name is $text now" : "ไม่สำเร็จ";
		return $replyText;
	}

	public function checkId(DatabaseInterface $con, $table, $admins, $targetNames)
	{
		if (!in_array($this->userId, $admins)) {
			return;
		}
		$targetName = $targetNames[1];
		unset($targetNames[0], $targetNames[1]);
		foreach ((array) $targetNames as $targetPart)
		{
			$targetName .= empty($targetPart) ? '' : " $targetPart";
		}
		$targetName = substr($targetName, 1);
		$resultRows = $con->startQuery()
			->select(['id'])
			->from('money', 'money')
			->where(['name' => $this->codename($targetName)])
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		$replyText = empty($resultRows[0]['id']) ? 'ไม่พบข้อมูล' : "$targetName id คือ ".$resultRows[0]['id'];
		return $replyText;
	}

	public function checkCount(DatabaseInterface $con, $table, $tags)
	{
		if (!in_array($this->admin, ['yes', 'super'])) {
			return;
		}
		$replyTexts = $this->flexMessage([
			'altText' => "รอบการเล่นจาการโอน",
			'header' => "รอบการเล่นจาการโอน",
		]);
		sort($tags);
		$i = 0;
		foreach ((array) $tags as $count => $tag)
		{
			$whereText = $con->select(['userId'])
				->from($table)
				->where('id>1')
				->build()
				->getSql();
			$resultRows = $con->startQuery()
				->select(['id', 'name', 'count', 'wage'])
				->from('money', 'money')
				->where("userId in ($whereText)")
				->and("tag = $tag")
				->and("count > 0")
				->and("wage > 0")
				->build()
				->query()
				->fetchAssoc();
			$con->close();
			if (!empty($resultRows)) {
				$normalReplys[$i] = "ยอดโอนมากกว่า $tag บาท";
				$replyTexts = $this->flexMessage([
					'old' => $replyTexts,
					'body' => [
						[
							"ยอดโอนมากกว่า $tag บาท",
						],
					],
				]);
				foreach ((array) $resultRows as $rows)
				{
					$normalReplys[$i] .= "\r\n".$rows['id'].") ".json_decode($rows['name'], 1).(int) $rows['count']."รอบ ".(int) $rows['wage']."บาท";
					$replyTexts = $this->flexMessage([
						'old' => $replyTexts,
						'body' => [
							[
								$rows['id'].") ".json_decode($rows['name'], 1),
								(int) $rows['count']."รอบ ".(int) $rows['wage']."บาท",
							],
						],
					]);
				}
			} else {
				$normalReplys[$i] = "ไม่มีผู้เล่นยอดโอนมากกว่า $tag บาท";
				$replyTexts = $this->flexMessage([
					'old' => $replyTexts,
					'body' => [
						[
							"ไม่มีผู้เล่นยอดโอนมากกว่า $tag บาท"
						],
					],
				]);
			}
			$i++;
		}
		if (count($replyTexts['messages'][0]['contents']['contents']) > 10) {
			$replyTexts = $normalReplys;
		}
		return $replyTexts;
	}

	public function checkMoney(DatabaseInterface $con, $table, $doNotSendUsers = [])
	{
		if ($this->bonus > 0) {
			$bonusText = "💸".$this->bonus."=".($this->bonus+$this->net);
		}
		if ($this->datas['reply'] == 'flex') {
			$replyTexts = $this->flexMessage([
				'altText' => "$this->name ID คือ $this->id เครดิตคงเหลือ 💰{$this->net}{$bonusText}",
				'header' => $this->name,
				'body' => [
					[
						"ID",
						"เครดิต",
						"โบนัส",
					],
					[
						$this->id,
						$this->net,
						"💸".$this->bonus,
					],
				],
			]);
		} else {
			$replyTexts = "$this->name ID คือ $this->id เครดิตคงเหลือ 💰{$this->net}{$bonusText}";
		}
		$con->startQuery()
			->update(['name' => $this->codename($this->name)])
			->set($table)
			->where(['userId' => $this->userId])
			->build()
			->query()
			->close();
		$con->startQuery()
			->update(['name' => $this->codename($this->name)])
			->set('money', 'money')
			->where(['userId' => $this->userId])
			->build()
			->query()
			->close();
		if (in_array($this->userId, $doNotSendUsers)) {
			unset($replyTexts);
		}
		return $replyTexts;
	}

	public function checkAllMoney(DatabaseInterface $con, $table, $isReportAll = false)
	{
		if (!in_array($this->admin, ['yes', 'super'])) {
			return;
		}
		$whereText = $con->select(['userId'])
			->from($table)
			->where('id>1')
			->build()
			->getSql();
		$resultRows = $con->startQuery()
			->select(['id', 'name', 'net', 'bonus'])
			->from('money', 'money')
			->where("userId in ($whereText)")
			->and('net>0')
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		if (!empty($resultRows)) {
			$replyTexts = $this->flexMessage([
				'altText' => "สรุปยอด",
				'header' => "สรุปยอด",
			]);
			foreach ((array) $resultRows as $rows)
			{
				$replyTexts = $this->flexMessage([
					'old' => $replyTexts,
					'body' => [
						[
							$rows['id'].") ".json_decode($rows['name'], 1),
							$rows['net']."💸".(int) $rows['bonus'],
						],
					],
				]);
				$allMoney += $rows['net'];
				$allBonus += $row['bonus'];
			}
			if ($isReportAll) {
				$replyTexts = $this->flexMessage([
					'old' => $replyTexts,
					'footer' => "รวม {$allMoney}💸{$allBonus}",
				]);
			}
		} else {
			$replyTexts = "ไม่มีผู้เล่นยอดเกิน 0";
		}
		return $replyTexts;
	}

	public function checkPeople(DatabaseInterface $con, $table, $isReturnOnlyNumber = false)
	{
		if (!in_array($this->admin, ['yes', 'super']) && !$isReturnOnlyNumber) {
			return;
		}
		$resultRows = $con->startQuery()
			->select(['content'])
			->from($table)
			->where(['result' => 'playing'])
			->and('id > 1')
			->build()
			->query()
			->fetchAssoc();
		$con->close();
		if ($isReturnOnlyNumber) {
			return (int) count((array) $resultRows);
		}
		if (!empty($resultRows)) {
			$count = count($resultRows);
			$replyTexts = $this->flexMessage([
				'altText' => 'จำนวนคนแทงรอบย่อยที่ #'.$this->datas['lap'],
				'header' => 'จำนวนคนแทงรอบย่อยที่ #'.$this->datas['lap'],
				'body' => [
					[
						'จำนวนแทง',
						(int) $count,
						'คน',
					],
				],
			]);
		} else {
			$replyTexts = 'ไม่พบผู้เล่น';
		}
		return $replyTexts;
	}

	public function fixMoney(DatabaseInterface $con, $table, $text)
	{
		if (!in_array($this->admin, ['yes', 'super'])) {
			return;
		}
		if ($this->datas['$'] == 'yes' && $this->datas['status'] == 'down') {
			return "ยังไม่เปิดเกม";
		}
		if ($text == '$') {
			if ($this->datas['$'] == 'yes') {
				return "$(id) (+ หรือ -)ยอดเงินที่จะเพิ่มหรือลด (+จำนวน % เฉพาะการเพิ่ม) เช่น \"$12+1000+10\"";
			} else {
				return "$(id) (+ หรือ -)ยอดเงินที่จะแก้ไข เช่น \"$12+1000\"";
			}
		}
		$operator = stripos($text, '+') ? '+' : '-';
		$explodeTexts = explode($operator, $text);
		$memberId = substr($explodeTexts[0], 1);
		$changeNet = $explodeTexts[1];
		$receiveRows = $con->startQuery()
			->select(['userId', 'name', 'net', 'bonus'])
			->from('money', 'money')
			->where(['id' => $memberId])
			->build()
			->query()
			->fetchAssoc()[0];
		$con->close();
		$memberUserId = $receiveRows['userId'];
		$memberName = json_decode($receiveRows['name'], 1);
		$memberNet = $receiveRows['net'];
		$bonus = $receiveRows['bonus'];

		if (!empty($memberUserId)) {
			if ($operator == '+') {
				$prefix = 'เพิ่ม';
				$remaining = $memberNet + $changeNet;
				$fixNet = "+$changeNet";
				if (!empty($explodeTexts[2])) {
					$percent = substr($explodeTexts[2], 0, strlen($explodeTexts[2]));
					$bonus += number_format($changeNet*$percent/100, 0, '.', '');
					$bonusText = "💸".$bonus;
				}
			} else {
				$prefix = 'ลด';
				$remaining = $memberNet - $changeNet;
				$fixNet = "-$changeNet";
			}
			$con->startQuery()
				->update(['net' => $remaining, 'bonus' => $bonus])
				->set('money', 'money')
				->where(['userId' => $memberUserId])
				->build();
			if ($con->query(true)) {
				$con->close();
				if ($this->datas['$'] == 'yes') {
					date_default_timezone_set('Asia/Bangkok');
					$con->startQuery()
						->insert([
							'amount' => (int) $fixNet,
							'bonus'  => (int) $bonus,
							'time'   => date('H:i'),
							'date'   => date('j'),
							'month'  => date('n'),
							'year'   => date('Y'),
							'user'   => $this->userId,
							'game'   => $this->database.$this->datas['game'],
						])
						->into('reportMoney', 'money')
						->build()
						->query()
						->close();
				} else {
					$reports = [
						'game'     => $this->datas['game'],
						'bigLap'   => $this->datas['bigLap'],
						'lap'      => $this->datas['lap'],
						'fix'      => (int) $fixNet,
					];
					$this->report($con, $table, $reports);
				}
				$replyText = "{$prefix}เครดิต $memberName $fixNet = 💰{$remaining}{$bonusText}";
			} else {
				$con->close();
			}
		} else {
			$replyText = 'โปรดระบุเลข id ให้ถูกต้อง';
		}
		return $replyText;
	}

	public function flexMessage($text, $size = 'default', $type = 'each')
	{
		if ($type == 'each') {
			if ($size == 'default') {
				$size = 'md';
			}
			if (!empty($text['altText'])) {
				$text['old']['messages'][0]['type'] = 'flex';
				$text['old']['messages'][0]['altText'] = $text['altText'];
				$text['old']['messages'][0]['contents']['type'] = 'carousel';
			}
			$bubbles = (array) $text['old']['messages'][0]['contents']['contents'];
			$bubble = count((array) $bubbles)-1;
			if ($bubble < 0) {
				$bubble = 0;
			}
			if (count((array) $bubbles[$bubble]['body']['contents']) >= 20 || $text['new']) {
				$bubble++;
			}
			if (empty($bubbles[$bubble])) {
				$bubbles[$bubble] = [
					"type" => "bubble",
					"direction" => "ltr",
					"styles" => [
						"header" => [
							"backgroundColor" => "#06BB1C",
						],
					],
				];
				if (!empty($text['old']['messages'][0]['contents']['contents'][$bubble-1]['header'])) {
					$bubbles[$bubble]['header'] = $text['old']['messages'][0]['contents']['contents'][$bubble-1]['header'];
				}
			}
			if (!empty($text['header'])) {
				if ($size == 'md') {
					$hsize = 'lg';
				} else {
					$hsize = 'md';
				}
				$bubbles[$bubble]['header'] = [
					"type" => "box",
					"layout" => "vertical",
					"contents" => [
						[
							"type" => "text",
							"text" => (string) $text['header'],
							"size" => $hsize,
							"weight" => "bold",
							"color" => "#FFFFFF",
						],
					],
				];
			}
			if (!empty($text['body'])) {
				if (empty($bubbles[$bubble]['body'])) {
					$bubbles[$bubble]['body'] = [
						"type" => "box",
						"layout" => "vertical",
					];
				}
				foreach ((array) $text['body'] as $body)
				{
					unset($contents);
					foreach ((array) $body as $b)
					{
						if (empty($body)) {
							continue;
						}
						$explodeBody = explode(' ', $b);
						if (in_array('separator', $explodeBody)) {
							$separator = empty($explodeBody[1]) ? 'default' : $explodeBody[1];
							continue;
						}
						if ($b == $body[0]) {
							$contents[] = [
								"type" => "text",
								"text" => (string) $b,
								"align" => "start",
								"size" => $size,
							];
						} else if ($b == end($body)) {
							$contents[] = [
								"type" => "text",
								"text" => (string) $b,
								"align" => "end",
								"size" => $size,
							];
						} else {
							$contents[] = [
								"type" => "text",
								"text" => (string) $b,
								"align" => "center",
								"size" => $size,
							];
						}
					}
					if (!empty($contents)) {
						if (count($contents) == 1) {
							$contents[0]["wrap"] = true;
						}
						$bubbles[$bubble]['body']['contents'][] = [
							"type" => "box",
							"layout" => "horizontal",
							"contents" => $contents,
						];
					}
				}
				if (!empty($separator)) {
					if ($separator == 'default') {
						$bubbles[$bubble]['body']['contents'][] = [
							"type" => "separator",
						];
					} else {
						$bubbles[$bubble]['body']['contents'][] = [
							"type" => "separator",
							"color" => $separator,
						];
					}
				}
			}
			if (!empty($text['footer'])) {
				if (empty($bubbles[$bubble]['footer'])) {
					$bubbles[$bubble]['footer'] = [
						"type" => "box",
						"layout" => "horizontal",
					];
				}
				$bubbles[$bubble]['footer']['contents'][] = [
					"type" => "text",
					"text" => $text['footer'],
					"align" => "end",
					"weight" => "bold",
					"size" => $size,
				];
			}
			if (!empty($text['button'])) {
				if (empty($bubbles[$bubble]['footer'])) {
					$bubbles[$bubble]['footer'] = [
						"type" => "box",
						"layout" => "horizontal",
					];
				}
				foreach ((array) $text['button'] as $buttons)
				{
					$bubbles[$bubble]['footer']['contents'][] = [
						"type" => "button",
						"action" => $buttons,
					];
				}
			}
			$text['old']['messages'][0]['contents']['contents'] = $bubbles;
			$text['old']['raw'] = true;
			$replyTexts = $text['old'];
		} else if ($type == 'line') {
			if ($size == 'default') {
				$size = 'sm';
			}
			$headerColor = "#1DB446";
			$text = str_replace("\r\n", "\n", $text);
			$texts = explode("\n", $text);
			if (sizeof($texts) == 1) {
				$replyTexts = [
					"raw" => true,
					"messages" => [
						[
							"type" => "text",
							"text" => $text,
						]
					],
				];
				return $replyTexts;
			}
			$header = [
				"type" => "box",
				"layout" => "vertical",
				"contents" => [
					[
						"type" => "text",
						"text" => $texts[0],
						"wrap" => true,
						"color" => "#ffffff",
					]
				],
			];
			unset($texts[0]);
			$i = $j = 0;
			$contents[$i] = [
				"type" => "bubble",
				"styles" => [
					"header" => [
						"backgroundColor" => $headerColor,
					],
				],
				"header" => $header,
				"body" => [
					"type" => "box",
					"layout" => "vertical",
				],
			];
			foreach ((array) $texts as $text)
			{
				if ($j >= 20) {
					$j = 0;
					$i++;
					$contents[$i] = [
						"type" => "bubble",
						"styles" => [
							"header" => [
								"backgroundColor" => $headerColor,
							],
						],
						"header" => $header,
						"body" => [
							"type" => "box",
							"layout" => "vertical",
						],
					];
				}
				$contents[$i]['body']['contents'][$j++] = [
					"type" => "text",
					"text" => " $text",
					"wrap" => true,
					"size" => $size,
				];
			}
			$replyTexts = [
				"raw" => true,
				"messages" => [
					[
						"type" => "flex",
						"altText" => $header['contents'][0]['text'],
						"contents" => [
							"type" => "carousel",
							"contents" => $contents,
						],
					]
				]
			];
		}
		return $replyTexts;
	}

	public function status(DatabaseInterface $con, $admins)
	{
		if (!in_array($this->userId, $admins)) {
			return;
		}
		$replyText = print_r($this->datas, 1);
		return $replyText;
	}

	public function test($text)
	{
		if (!in_array($this->admin, ['yes', 'super']))
			return;
		$text = substr($text, 5);
		return json_encode($text);
	}

	public function codename($name)
	{
		$name = json_encode($name);
		$name = str_replace('\\', '\\\\', $name);
		$name = str_replace("'","\\'", $name);
		return $name;
	}

	public function fix_array(&$inputs, $paths, $value)
	{
		foreach ((array) $paths as $path)
		{
			if (empty($inputs[$path])) {
				$inputs = [$path => null];
				$inputs = &$inputs[$path];
			} else {
				$inputs = &$inputs[$path];
			}
		}
		$inputs = $value;
	}
}