<?php
namespace Koob\IncomeOutcomeBundle\Controller;

use Koob\InterfaceBundle\IncomeOutcomeInterface;
use Koob\InterfaceBundle\DatabaseInterface;
use Koob\IncomeOutcomeBundle\Model\FunctionModel;

Class FunctionController implements IncomeOutcomeInterface
{
	protected $func;

	function __construct($model = null)
	{
		$model = empty($model) ? new FunctionModel : $model;
		$this->func = $model;
	}

	public function rebuildTable(DatabaseInterface $con)
	{
		return $this->func->rebuildTable($con);
	}

	public function check(DatabaseInterface $con, $date = null, $month = null, $year = null)
	{
		$date = empty($date) ? date('j') : $date;
		$month = empty($month) ? date('n') : $month;
		$year = empty($year) ? date('Y') : $year;
		return $this->func->check($con, $date, $month, $year);
	}

	public function checkAll(DatabaseInterface $con)
	{
		return $this->func->checkAll($con);
	}

	public function insert(DatabaseInterface $con, $contents)
	{
		return $this->func->insert($con, $contents);
	}

	public function fixContent(DatabaseInterface $con, $id, $contents)
	{
		return $this->func->fixContent($con, $id, $contents);
	}

	public function fixMoney(DatabaseInterface $con, $id, $money)
	{
		return $this->func->fixMoney($con, $id, $money);
	}

	public function setup(DatabaseInterface $con, $userId, $admin, $force = false)
	{
		return $this->func->setup($con, $userId, $admin, $force);
	}
}