<?php
namespace Koob\IncomeOutcomeBundle\Model;

use Koob\InterfaceBundle\LobbyInterface;
use Koob\DatabaseBundle\Controller\DatabaseController;
use Koob\IncomeOutcomeBundle\Controller\FunctionController;
use Koob\LocalBundle\Controller\LocalController;

class LobbyModel implements LobbyInterface
{
	protected $con;

	protected $func;

	protected $local;

	function __construct()
	{
		$this->con = new DatabaseController;
		$this->func = new FunctionController;
		$this->local = new LocalController;

		$this->con->setHost($this->local->getParameter('host'))
			->setUser($this->local->getParameter('user'))
			->setPass($this->local->getParameter('pass'))
			->setDatabase($this->local->getParameter('database'));
	}

	public function run($content)
	{
		if (!empty($content['events'])) {
			foreach ((array) $content['events'] as $events)
			{
				$userId = $events['source']['userId'];
				if (in_array($userId, $this->local->getParameter('allowGroups'))) {
					$originalText = $events['message']['text'];
					$text = str_replace([' ', "\r\n"], '', $originalText);
					$explodeTexts = explode(' ', $originalText);

					if (in_array($text[0], ['+', '-'])) {
						$replyText = $this->func->insert($this->con, $explodeTexts);
					}

					if (in_array($explodeTexts[0], ['c', 'C'])) {
						$replyText = $this->func->check($this->con, $explodeTexts[1], $explodeTexts[2], $explodeTexts[3]);
					}

					if (in_array($text, ['ca', 'Ca'])) {
						$replyText = $this->func->checkAll($this->con);
					}

					if (in_array($explodeTexts[0], ['fc', 'Fc'])) {
						$replyText = $this->func->fixContent($this->con, $explodeTexts[1], $explodeTexts);
					}

					if (in_array($explodeTexts[0], ['fm', 'Fm'])) {
						$replyText = $this->func->fixMoney($this->con, $explodeTexts[1], $explodeTexts[2]);
					}

					if (in_array($text, ['setup', 'Setup'])) {
						$replyText = $this->func->setup($this->con, $userId, $this->local->getParameter('admins'), $this->local->getParameter('forceRebuild'));
					}
				} else {
					$replyText = 'คุณไม่ใช่ผู้ถูกเลือก!!!!!!!!';
				}
				return $replyText;
			}
		}
	}
}