<?php
namespace Koob\InterfaceBundle;

interface GameInterface
{
	public function rebuildMoney(DatabaseInterface $con);

	public function rebuildReportMoney(DatabaseInterface $con);

	public function rebuildLogin(DatabaseInterface $con);

	public function rebuildReport(DatabaseInterface $con, $table);

	public function rebuildAllReport(DatabaseInterface $con, $table);

	public function getData(DatabaseInterface $con, $table, $userId);

	public function getApi(LineApiInterface $con, $ids);

	public function insert(DatabaseInterface $con, $table, $extraInserts);

	public function report(DatabaseInterface $con, $table, $reports);

	public function reportAll(DatabaseInterface $con, $table, $reports);

	public function resultOpen(DatabaseInterface $con, $table, $game, $resetTime);

	public function resultRest(DatabaseInterface $con, $table, $game, $bigLap, $resetTime, $startTime);

	public function resultClose(DatabaseInterface $con, $table, $game, $resetTime);

	public function withdraw(DatabaseInterface $con, $table, $text);

	public function confirmWithdraw(DatabaseInterface $con, $table, $text);

	public function showScore(DatabaseInterface $con, $table);

	public function changeAttr(DatabaseInterface $con, $name, $attr);

	public function saveRollBack(DatabaseInterface $con, $database);

	public function deleteAllMoney(DatabaseInterface $con, $database, $type);

	public function setAdmin(DatabaseInterface $con, $table, $admins, $adminId, $status);

	public function checkId(DatabaseInterface $con, $table, $admins, $targetNames);

	public function checkCount(DatabaseInterface $con, $table, $tags);

	public function checkMoney(DatabaseInterface $con, $table, $doNotSendUsers);

	public function checkAllMoney(DatabaseInterface $con, $table, $isReportAll);

	public function checkPeople(DatabaseInterface $con, $table, $isReturnOnlyNumber);

	public function fixMoney(DatabaseInterface $con, $table, $text);

	public function flexMessage($text, $size, $type);

	public function status(DatabaseInterface $con, $admins);

	public function codename($name);

	public function fix_array(&$inputs, $paths, $value);
}