<?php
namespace Koob\LineApiBundle\Controller;

use Koob\InterfaceBundle\LineApiInterface;
use Koob\LineApiBundle\Model\LineApiModel;

class LineApiController implements LineApiInterface
{
	protected $api;

	function __construct($model = null)
	{
		$model = empty($model) ? new LineApiModel : $model;
		$this->api = $model;
	}

	public function startApi()
	{
		$this->api->startApi();
		return $this;
	}

	public function setAccessToken($accessToken)
	{
		$this->api->setAccessToken($accessToken);
		return $this;
	}

	public function setDestination($destination)
	{
		$this->api->setDestination($destination);
		return $this;
	}

	public function setIgnore($ignores)
	{
		$this->api->setIgnore($ignores);
		return $this;
	}

	public function setMessage($messages, $israw = false)
	{
		$this->api->setMessage($messages, $israw);
		return $this;
	}

	public function setUrl($url)
	{
		$this->api->setUrl($url);
		return $this;
	}

	public function setType($type)
	{
		$this->api->setType($type);
		return $this;
	}

	public function setOption($optionName, $option)
	{
		$this->api->setHeader($optionName, $option);
		return $this;
	}

	public function setRoomId($roomId)
	{
		$this->api->setRoomId($roomId);
		return $this;
	}

	public function setGroupId($groupId)
	{
		$this->api->setGroupId($groupId);
		return $this;
	}

	public function setMethod($method)
	{
		$this->api->setMethod($method);
		return $this;
	}

	public function send()
	{
		$this->api->send();
		return $this;
	}

	public function get($line)
	{
		return $this->api->get($line);
	}

	public function sendNotify($token, $message, $count = 0)
	{
		return $this->api->sendNotify($token, $message, $count);
	}

	public function close()
	{
		$this->api->close();
	}
}