<?php
namespace Koob\LobbyBundle\Model;

use Koob\LineApiBundle\Controller\LineApiController;
use Koob\LocalBundle\Controller\LocalController;
use Koob\LocalBundle\Controller\LocalDatabaseController;

class FunctionModel
{
	protected $api;

	protected $local;

	protected $localDatabase;

	function __construct()
	{
		$this->api = new LineApiController;
		$this->local = new LocalController;
		$this->localDatabase = new LocalDatabaseController;
	}

	public function getName($game)
	{
		$allGames = $this->local->getParameter('availableGames');
		$allGameNames = $this->local->getParameter('availableGameNames');
		$position = array_keys($allGames, $game)[0];
		$name = $allGameNames[$position];
		return $name;
	}

	public function getGame($name)
	{
		$allGames = $this->local->getParameter('availableGames');
		$allGameNames = $this->local->getParameter('availableGameNames');
		$position = array_keys($allGameNames, $name)[0];
		$game = $allGames[$position];
		return $name;
	}

	public function thisGame()
	{
		$thisGame = $this->localDatabase->getParameter('game');
		$thisGameName = $this->getName($thisGame);
		return $thisGameName;
	}

	public function allGame()
	{
		$allGames = $this->local->getParameter('availableGameNames');
		foreach ((array) $allGames as $number => $game) {
			$number++;
			$reply .= empty($reply) ? "{$number}) $game" : "\r\n{$number}) $game" ;
		}
		return $reply;
	}

	public function changeGame($number)
	{
		$allGames = $this->local->getParameter('availableGames');
		$game = $allGames[$number-1];
		$this->localDatabase->setParameter('game', $game);
	}
}