<?php
namespace Koob\LobbyBundle\Model;

use Koob\InterfaceBundle\LobbyInterface;
use Koob\LineApiBundle\Controller\LineApiController;
use Koob\LobbyBundle\Controller\FunctionController;
use Koob\LocalBundle\Controller\LocalDatabaseController;
use Koob\LocalBundle\Controller\LocalController;

class LobbyModel implements LobbyInterface
{
	protected $api;

	protected $localDatabase;

	protected $func;

	function __construct()
	{
		$this->api = new LineApiController;
		$this->localDatabase = new LocalDatabaseController;
		$this->local = new LocalController;
		$this->func = new FunctionController;

		$this->api->setAccessToken($this->local->getParameter('accessToken'))
			->setMethod('reply');
	}

	public function run($contents)
	{
		if (empty($contents)) {
			$bundle = "Koob\\ViewBundle\\Controller\\LobbyController";
			$lobby = new $bundle;
			$lobby->run($contents);
			return;
		}
		$admins = $this->local->getParameter('admins');
		if (!empty($contents['events'])) {
			foreach ((array) $contents['events'] as $events)
			{
				$replyToken = $events['replyToken'];
				$text = $events['message']['text'];
				$explodes = explode(' ', $text);
				if (in_array($events['source']['userId'], $admins)) {
					if (in_array($text, ['เกมอะไร', 'this game', 'This game'])) {
						$replyText = $this->func->thisGame();
					}

					if (in_array($text, ['เกมทั้งหมด', 'all game', 'All game'])) {
						$replyText = $this->func->allGame();
					}

					if (in_array($explodes[0], ['เปลี่ยนเกม', 'change', 'Change'])) {
						$this->func->changeGame($explodes[1]);
						$replyText = 'เกมปัจจุบัน : '.$this->func->thisGame();
					}
				}
				if (in_array($explodes[0], ['my', 'My'])) {
					$replyText = $events['source'][$explodes[1]];
				}

				if (isset($replyText)) {
					$this->send($replyToken, $replyText);
					print_r($replyText);echo "\n";
					return;
				}
			}
		}

		$game = $this->localDatabase->getParameter('game');
		if (!empty($game)) {
			$bundle = "Koob\\{$game}Bundle\\Controller\\LobbyController";
			if (class_exists($bundle)) {
				$lobby = new $bundle;
				$replyText = $lobby->run($contents);
			} else {
				$replyText = 'ไม่พบเกม';
			}
			if (isset($replyText)) {
				$this->send($replyToken, $replyText);
			}
			print_r($replyText);echo "\n";
		} else {
			$this->func->changeGame(1);
			$this->run($contents);
		}
		if ($myfile = fopen(dirname(dirname(dirname(__DIR__))).'/logs/index.log', 'w')) {
			fwrite($myfile, "input :\n");
			fwrite($myfile, print_r($contents, 1));
			fwrite($myfile, "\n");
			fwrite($myfile, "output :\n");
			fwrite($myfile, print_r($replyText, 1));
			fwrite($myfile, "\n");
			fclose($myfile);
		}
	}

	public function send($destination, $replyTexts)
	{
		if (!empty($replyTexts['raw'])) {
			$isRaw = true;
			$replyTexts = $replyTexts["messages"];
		} else {
			$isRaw = false;
		}
		$this->api->startApi()
			->setDestination($destination)
			->setMessage($replyTexts, $isRaw)
			->send()
			->close();
	}
}