<?php
namespace Koob\LocalBundle\Storage;

use Koob\InterfaceBundle\LocalDatabaseInterface;

class LocalDatabaseStorage implements LocalDatabaseInterface
{
	static protected $localParams;

	protected $file;

	function __construct()
	{
		$dirname = dirname(dirname(dirname(__DIR__)));
		$this->file = $dirname.'/config/database.php';
		if (file_exists($this->file)) {
			include $this->file;
			static::$localParams = isset($localParam) ? json_decode($localParam, 1) : static::$localParams;
		}
	}

	public function getParameter($parameter)
	{
		return static::$localParams[$parameter];
	}

	public function setParameter($parameter, $value)
	{
		static::$localParams[$parameter] = $value;
		$this->updateParameter();
	}

	public function unsetParameter($parameter)
	{
		unset(static::$localParams[$parameter]);
		$this->updateParameter();
	}

	protected function updateParameter()
	{
		$myfile = fopen($this->file, 'w') or die("Unable to open file!");
		flock($myfile, LOCK_EX);
		fwrite($myfile, "<?php\n");
		$postDatas = static::$localParams;
		$postData = json_encode($postDatas);
		$postData = str_replace('{', "{\n\t", $postData);
		$postData = str_replace('}', "\n}", $postData);
		$postData = str_replace(',', ",\n\t", $postData);
		fwrite($myfile, '$localParam = '."'".$postData."';");
		flock($myfile, LOCK_UN);
		fclose($myfile);
	}
}