<?php
namespace Koob\PokeBundle\Controller;

use Koob\InterfaceBundle\PokeInterface;
use Koob\InterfaceBundle\DatabaseInterface;
use Koob\GameBundle\Controller\GameController;
use Koob\PokeBundle\Model\FunctionModel;

class FunctionController extends GameController implements PokeInterface
{
	protected $func;

	function __construct($model = null)
	{
		$model = empty($model) ? new FunctionModel : $model;
		$this->func = $model;
		$this->game = $model;
	}

	public function rebuildPoke(DatabaseInterface $con)
	{
		return $this->func->rebuildPoke($con);
	}

	public function wage(DatabaseInterface $con, $text)
	{
		if (is_numeric($text[0])) {
			return $this->func->wage($con, $text);
		} else {
			return;
		}
	}

	public function unWage(DatabaseInterface $con, $text)
	{
		return $this->func->unWage($con, $text);
	}

	public function unWageAll(DatabaseInterface $con)
	{
		return $this->func->unWageAll($con);
	}

	public function domulti(DatabaseInterface $con)
	{
		return $this->func->domulti($con);
	}

	public function doUnmulti(DatabaseInterface $con)
	{
		return $this->func->doUnmulti($con);
	}

	public function check()
	{
		return $this->func->check();
	}

	public function checkAll(DatabaseInterface $con)
	{
		return $this->func->checkAll($con);
	}

	public function openGame(DatabaseInterface $con, $resetTime)
	{
		return $this->func->openGame($con, $resetTime);
	}

	public function openRound(DatabaseInterface $con, $locals)
	{
		return $this->func->openRound($con, $locals);
	}

	public function closeRound(DatabaseInterface $con, $locals)
	{
		return $this->func->closeRound($con, $locals);
	}

	public function restRound(DatabaseInterface $con, $resetTime)
	{
		return $this->func->restRound($con, $resetTime);
	}

	public function closeGame(DatabaseInterface $con, $resetTime)
	{
		return $this->func->closeGame($con, $resetTime);
	}

	public function saveResult(DatabaseInterface $con, $text)
	{
		return $this->func->saveResult($con, $text);
	}

	public function submit(DatabaseInterface $con)
	{
		return $this->func->submit($con);
	}

	public function setup(DatabaseInterface $con, $admins, $force = false)
	{
		return $this->func->setup($con, $admins, $force);
	}
}