<?php
namespace Koob\TigerDragonBundle\Controller;

use Koob\InterfaceBundle\TigerDragonInterface;
use Koob\InterfaceBundle\DatabaseInterface;
use Koob\InterfaceBundle\LineApiInterface;
use Koob\GameBundle\Controller\GameController;
use Koob\TigerDragonBundle\Model\FunctionModel;

class FunctionController extends GameController implements TigerDragonInterface
{
	protected $func;

	function __construct($model = null)
	{
		$model = empty($model) ? new FunctionModel : $model;
		$this->func = $model;
		$this->game = $model;
	}

	public function rebuildTigerDragon(DatabaseInterface $con)
	{
		return $this->func->rebuildTigerDragon($con);
	}

	public function wage(DatabaseInterface $con, $text)
	{
		$allowFirstCharecters = ['t', 'd', 'td', 'b', 'r', 1, 2, 3, 4, 'p', 'e'];
		if (in_array($text[0], $allowFirstCharecters)) {
			return $this->func->wage($con, $text);
		} else {
			return;
		}
	}

	public function unWage(DatabaseInterface $con, $text)
	{
		return $this->func->unWage($con, $text);
	}

	public function unWageAll(DatabaseInterface $con)
	{
		return $this->func->unWageAll($con);
	}

	public function check()
	{
		return $this->func->check();
	}

	public function checkAll(DatabaseInterface $con)
	{
		return $this->func->checkAll($con);
	}

	public function openGame(DatabaseInterface $con, $resetTime)
	{
		return $this->func->openGame($con, $resetTime);
	}

	public function openRound(DatabaseInterface $con, $locals)
	{
		return $this->func->openRound($con, $locals);
	}

	public function closeRound(DatabaseInterface $con, $locals)
	{
		return $this->func->closeRound($con, $locals);
	}

	public function restRound(DatabaseInterface $con, $resetTime)
	{
		return $this->func->restRound($con, $resetTime);
	}

	public function closeGame(DatabaseInterface $con, $resetTime)
	{
		return $this->func->closeGame($con, $resetTime);
	}

	public function saveResult(DatabaseInterface $con, $text)
	{
		return $this->func->saveResult($con, $text);
	}

	public function submit(DatabaseInterface $con)
	{
		return $this->func->submit($con);
	}

	public function setup(DatabaseInterface $con, $admins, $force = false)
	{
		return $this->func->setup($con, $admins, $force);
	}
}