<?php
namespace Koob\ViewBundle\Model;

use Koob\InterfaceBundle\LobbyInterface;
use Koob\DatabaseBundle\Controller\DatabaseController;
use Koob\LineApiBundle\Controller\LineApiController;
use Koob\LocalBundle\Controller\LocalController;
use Koob\ViewBundle\Controller\FunctionController;

class LobbyModel implements LobbyInterface
{
	protected $con;

	protected $api;

	protected $local;

	protected $func;

	function __construct()
	{
		$this->con = new DatabaseController;
		$this->api = new LineApiController;
		$this->local = new LocalController;
		$this->func = new FunctionController;

		$this->con->setHost($this->local->getParameter('host'))
			->setPass($this->local->getParameter('pass'))
			->setUser($this->local->getParameter('user'))
			->setDatabase($this->local->getParameter('database'));

		$this->api->setAccessToken($this->local->getParameter('accessToken'))
			->setMethod('push');
	}

	public function run($contents)
	{
		// $dir = $_SERVER['REQUEST_URI'];
		// echo "<!DOCTYPE html>\r\n";
		// echo "<head>\r\n";
		// require_once dirname(__DIR__).'/View/head.php';
		// echo "\r\n</head>";
		// echo "\r\n";
		// echo "<body>\r\n";
		// require_once dirname(__DIR__).'/View/topnav.php';
		// echo "\r\n";
		// require_once dirname(__DIR__).'/View/index.php';
		// echo "\r\n</body>";
		require_once dirname(dirname(dirname(__DIR__))).'/AdminLTE/reroute.html';
	}

	public function send($destination, $replyTexts)
	{
		$this->api->startApi()
			->setDestination($destination)
			->setMessage($replyTexts)
			->send()
			->close();
	}
}